#ifndef __RTL_SYNC__
#define __RTL_SYNC__

#define	rtl_no_interrupts(s) \
__asm__ __volatile__("pushfl ; popl %0; cli":"=g" (s): /* no input */ :"memory")

#define	 rtl_restore_interrupts(s)\
__asm__ __volatile__("pushl %0 ; popfl": /* no output */ :"g" (s):"memory")

#define	 rtl_stop_interrupts()\
__asm__ __volatile__("cli": /* no output,no input */ ::"memory")

#define	 rtl_allow_interrupts() \
__asm__ __volatile__("sti": /* no output,no input */ :: "memory")


/* compatibility functions */

#define r_cli() rtl_stop_interrupts()
#define r_sti() rtl_allow_interrupts()
#define r_save_flags(s) __asm__ __volatile__("pushfl ; popl %0":"=g" (s): /* no input */ :"memory")
#define r_restore_flags(s) rtl_restore_interrupts(s)

/* end of compatibility functions */

#ifdef __SMP__
#define rtl_spin_lock(x)  { static int z;\
	for(z=0;z<1000000000;z++)\
		if(!test_and_set_bit(0,x.lock)) \
			break;\
	if(z==1000000000){\
		conpr("\nRTLBADSpin=");\
		conprn((unsigned int)&z);\
	}}

#define rtl_spin_unlock(x)   clear_bit(0,x.lock);
#else
#define rtl_spin_lock(x)  
#define rtl_spin_unlock(x)  
#endif

#include <asm/spinlock.h>

#define rtl_spin_lock_irqsave(x, flags) \
	do { rtl_no_interrupts(flags); spin_lock(x); } while (0)
#define rtl_spin_unlock_irqrestore(x, flags) \
	do { spin_unlock(x); rtl_restore_interrupts(flags); } while (0)

#ifdef __SMP__
/* #define rtl_critical(f) {rtl_no_interrupts(f); rtl_spin_lock(&RTL_SPIN_LOCK);} */
/* #define rtl_end_critical(f) {rtl_spin_unlock(&RTL_SPIN_LOCK); rtl_restore_interrupts(f);} */
#define rtl_critical(f) {rtl_spin_lock_irqsave(&RTL_SPIN_LOCK, f);}
#define rtl_end_critical(f) {rtl_spin_unlock_irqrestore(&RTL_SPIN_LOCK, f);}
#else
#define rtl_critical(f) rtl_no_interrupts(f)
#define rtl_end_critical(f) rtl_restore_interrupts(f);
#endif



#endif

