#include <linux/smp.h>
#include <asm/system.h>
#include <linux/tasks.h>

#include "../include/rtl_sched.h"
#include <linux/rtl.h>
#include <linux/cons.h>

static int rtl_linux_saved_ts[NR_CPUS];

int is_set_TS(void)
{
	int current_TS;
	__asm__("movl %%cr0,%%eax;andl $8,%%eax;movl %%eax,%0" \
			:"=m" (current_TS)/*output*/ \
			: /* no inputs */ \
			:"ax");
	return current_TS;
}


void rtl_fpu_save (RTL_THREAD *current_t)
{
	if (rtl_is_linux_task(rtl_get_cpu_id(), current_t)) {
		rtl_linux_saved_ts[rtl_get_cpu_id()] = is_set_TS();
		clts();
	}
	__asm__("fsave %0" : "=m" (current_t->fpu_regs));
}


void rtl_fpu_restore (RTL_THREAD *current_t) {
	clts (); /* just in case */
	__asm__("frstor %0" : "=m" (current_t->fpu_regs));
	if (rtl_is_linux_task(rtl_get_cpu_id(), current_t)
			&& rtl_linux_saved_ts[rtl_get_cpu_id()]) {
		stts();
	}
}


/*
static int rt_is_fpu_used ()
{
	for (t = RTL_THREADs; t; t = t->next) {
		if (t -> uses_fp) {
			return 1;
		}
	}
	return 0;
}
*/


void rtl_task_init_fpu (RTL_THREAD *t, RTL_THREAD *fpu_owner)
{
	int was_set_TS;
	/* we  must save/restore the fpu state*/
	if (fpu_owner) {
		if ((was_set_TS = is_set_TS())) {
			conpr("doing clts\n");
			clts();
			conpr("clts passed\n");
		}
		__asm__("fsave %0" : "=m" (fpu_owner -> fpu_regs));
		__asm__("finit");
		conpr("finit passed\n");
		__asm__("fsave %0" : "=m" (t->fpu_regs));
		__asm__("frstor %0" : "=m" (fpu_owner -> fpu_regs));
		if (was_set_TS) {
			stts();
			conpr("stts passed\n");
		}
	} else {
		clts ();
		__asm__("finit");
	}
	return ;
}


